<!--
SPDX-FileCopyrightText: 2020 Framasoft <https://framasoft.org>
SPDX-FileContributor: Thomas Citharel <thomas.citharel@framasoft.org>

SPDX-License-Identifier: AGPL-3.0-only
-->

<template>
	<NcSettingsSection
		id="csp_editor"
		:name="t('csp_editor', 'CSP Editor')"
		:description="
			t('csp_editor', 'Allows to edit Nextcloud\'s default CSP policy.')
		">
		<NcNoteCard type="warning">
			<p>
				{{
					t(
						'csp_editor',
						'Note: Be extra careful with these settings, and add only what you need below.',
					)
				}}
			</p>
		</NcNoteCard>
		<form @submit.prevent="addCSPDomain">
			<div>
				<NcCheckboxRadioSwitch :checked.sync="allowEvalScript" type="switch">
					{{ t('csp_editor', 'Allow eval script') }}
				</NcCheckboxRadioSwitch>
				<em>
					{{
						t(
							'csp_editor',
							'Allow scripts to use eval(). Very dangerous. Can be useful for development. Might not work anymore in future versions of Nextcloud.',
						)
					}}
					<span v-if="!debug">
						{{
							t(
								'csp_editor',
								'You need to set "debug" => true in your config.php file to allow to use eval().',
							)
						}}</span
					>
				</em>
				<NcCheckboxRadioSwitch
					:checked.sync="allowInlineStyle"
					type="switch">
					{{ t('csp_editor', 'Allow inline styles') }}
				</NcCheckboxRadioSwitch>
				<em>{{ t('csp_editor', 'Allow inline styles to be used.') }}</em>
			</div>
			<div class="new_domain_policy">
				<h3>{{ t('csp_editor', 'Add a domain policy') }}</h3>
				<p>{{ t('csp_editor', 'Pick a policy type and enter a domain') }}</p>
				<div class="new_domain_policy__input_wrapper">
					<div class="new_domain_policy__input_wrapper__select">
						<NcSelect v-model="newPolicy.type" :options="policies" />
					</div>
					<div class="new_domain_policy__input_wrapper__text">
						<NcTextField
							:value.sync="newPolicy.domain"
							required
							:placeholder="t('csp_editor', 'domain.org')" />
					</div>
					<NcButton
						native-type="submit"
						type="primary"
						:aria-label="t('csp_editor', 'Create new domain policy')">
						{{ t('csp_editor', 'Create') }}
					</NcButton>
				</div>
			</div>
			<div v-if="newPolicies.length > 0">
				<ul class="policy-list">
					<li
						v-for="cspDomainPolicy in newPolicies"
						:key="`${cspDomainPolicy.type}:${cspDomainPolicy.domain}`"
						class="policy-list__item">
						<div>
							<span class="">
								{{ cspDomainPolicy.domain }}
							</span>
							<span class="">
								{{ policyTypeTranslation(cspDomainPolicy.type) }}
							</span>
						</div>
						<NcButton
							:aria-label="t('csp_editor', 'Remove domain policy')"
							@click="removePolicy(cspDomainPolicy)">
							<template #icon>
								<Delete />
							</template>
						</NcButton>
					</li>
				</ul>
				<NcButton
					native-type="reset"
					type="error"
					:aria-label="t('csp_editor', 'Remove all policies')"
					@click="resetAll">
					{{ t('csp_editor', 'Reset all') }}
				</NcButton>
			</div>
			<NcEmptyContent v-else>
				<template #name>
					{{ t('csp_editor', 'No custom policy set') }}
				</template>
				<template #icon>
					<CheckAll />
				</template>
			</NcEmptyContent>
		</form>
	</NcSettingsSection>
</template>
<script>
import { loadState } from '@nextcloud/initial-state'
import NcSettingsSection from '@nextcloud/vue/dist/Components/NcSettingsSection.js'
import NcEmptyContent from '@nextcloud/vue/dist/Components/NcEmptyContent.js'
import NcCheckboxRadioSwitch from '@nextcloud/vue/dist/Components/NcCheckboxRadioSwitch.js'
import NcSelect from '@nextcloud/vue/dist/Components/NcSelect.js'
import NcButton from '@nextcloud/vue/dist/Components/NcButton.js'
import NcTextField from '@nextcloud/vue/dist/Components/NcTextField.js'
import NcNoteCard from '@nextcloud/vue/dist/Components/NcNoteCard.js'
import { showError } from '@nextcloud/dialogs'
import CheckAll from 'vue-material-design-icons/CheckAll.vue'
import Delete from 'vue-material-design-icons/Delete.vue'
import { t } from '@nextcloud/l10n'

const defaultDomainPolicy = {
	allowedScriptDomains: [],
	allowedStyleDomains: [],
	allowedFontDomains: [],
	allowedImageDomains: [],
	allowedConnectDomains: [],
	allowedMediaDomains: [],
	allowedObjectDomains: [],
	allowedChildSrcDomains: [],
	allowedFrameDomains: [],
	allowedFrameAncestorDomains: [],
	allowedWorkerSrcDomains: [],
	allowedFormActionDomains: [],
	reportTo: [],
}

const obsoleteKeys = ['allowInlineScript']

const defaultPolicy = {
	allowEvalScript: false,
	allowInlineStyle: true,
	...defaultDomainPolicy,
}

export default {
	name: 'AdminSettings',
	components: {
		NcSettingsSection,
		NcEmptyContent,
		NcCheckboxRadioSwitch,
		NcSelect,
		NcButton,
		NcTextField,
		CheckAll,
		Delete,
		NcNoteCard,
	},
	data() {
		return {
			cspPolicy: defaultPolicy,
			debug: false,
			appName: 'csp_editor',
			newPolicy: {
				domain: '',
				type: {
					value: 'allowedScriptDomains',
					label: t('csp_editor', 'Script'),
				},
			},
			types: {
				allowedScriptDomains: t('csp_editor', 'Script'),
				allowedStyleDomains: t('csp_editor', 'Style'),
				allowedFontDomains: t('csp_editor', 'Font'),
				allowedImageDomains: t('csp_editor', 'Image'),
				allowedConnectDomains: t('csp_editor', 'Connect'),
				allowedMediaDomains: t('csp_editor', 'Media'),
				allowedObjectDomains: t('csp_editor', 'Object'),
				allowedChildSrcDomains: t('csp_editor', 'Child'),
				allowedFrameDomains: t('csp_editor', 'Frame'),
				allowedFrameAncestorDomains: t('csp_editor', 'Frame Ancestor'),
				allowedWorkerSrcDomains: t('csp_editor', 'WorkerSrc'),
				allowedFormActionDomains: t('csp_editor', 'Form Action'),
				reportTo: t('csp_editor', 'Report To'),
			},
		}
	},
	computed: {
		newPolicies() {
			const newPolicies = []
			Object.entries(this.cspPolicy).forEach(([key, values]) => {
				if (
					![
						'allowInlineScript',
						'allowEvalScript',
						'allowInlineStyle',
					].includes(key)
				) {
					values.forEach((val) => {
						newPolicies.push({ type: key, domain: val })
					})
				}
			})
			return newPolicies
		},
		policies() {
			return Object.entries(this.types).map(([value, label]) => ({
				value,
				label,
			}))
		},
		allowEvalScript: {
			get() {
				return this.cspPolicy.allowEvalScript
			},
			set(newValue) {
				this.cspPolicy.allowEvalScript = newValue
				this.saveCSP()
			},
		},
		allowInlineStyle: {
			get() {
				return this.cspPolicy.allowInlineStyle
			},
			set(newValue) {
				this.cspPolicy.allowInlineStyle = newValue
				this.saveCSP()
			},
		},
	},
	created() {
		try {
			this.debug = loadState(this.appName, 'debug')
			let policy = loadState(this.appName, 'customCSP')
			policy = JSON.parse(policy)
			console.debug('Policy from server is', policy)
			if (!Array.isArray(policy) && Object.keys(policy).length > 0) {
				this.cspPolicy = {
					...defaultPolicy,
					...policy,
				}
				console.debug('Policy from server with defaults is', this.cspPolicy)
			}
		} catch (e) {
			console.error('Error fetching initial state', e)
		}
	},
	methods: {
		policyTypeTranslation(type) {
			return this.types[type]
		},
		addCSPDomain() {
			const domain = this.newPolicy.domain.trim()
			this.cspPolicy[this.newPolicy.type.value].push(domain)
			this.newPolicy.domain = ''
			this.saveCSP()
		},
		saveCSP() {
			try {
				obsoleteKeys.forEach((obsoleteKey) => {
					delete this.cspPolicy[obsoleteKey]
				})
				this.OCP.AppConfig.setValue(
					this.appName,
					'customCSP',
					JSON.stringify(this.cspPolicy),
				)
			} catch (e) {
				console.error(e)
				showError(t('csp_editor', 'Error while saving custom CSP policy'))
			}
		},
		removePolicy(policyToRemove) {
			this.cspPolicy[policyToRemove.type] = this.cspPolicy[
				policyToRemove.type
			].filter((domain) => {
				return domain !== policyToRemove.domain
			})
			this.saveCSP()
		},
		resetAll() {
			this.cspPolicy = defaultPolicy
			this.saveCSP()
		},
	},
}
</script>
<style lang="scss" scoped>
.new_domain_policy {
	&__input_wrapper {
		display: flex;
		gap: 1rem;
		align-items: center;

		&__text {
			width: 300px;
			height: 44px;

			& :deep(.input-field__input) {
				height: 44px !important;
			}
		}
	}
}

ul.policy-list {
	max-width: 18rem;
	gap: 1rem;
	display: flex;
	flex-direction: column;
	margin: 1rem 0;

	li {
		display: flex;
		justify-content: space-between;

		div {
			display: flex;
			flex-direction: column;
			overflow: hidden;
			white-space: nowrap;

			span:first-child {
				text-overflow: ellipsis;
				overflow: hidden;
			}

			span:last-child {
				color: var(--color-text-lighter);
			}
		}
	}
}

#csp_editor .empty-content {
	margin-top: 2rem;
	max-width: min(30rem, 100%);
}

.new_domain_policy__input_wrapper__text :deep(.input-field) {
	margin-block-start: 0;
}
</style>
